//----------------------------------------------------
//
// Shaded Trading Zone
//
//-----------------------------------------------------

#property  copyright "dave88"
#property  link      "....@gmail.com"
//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 3
//----
#property  indicator_color1  LimeGreen
#property  indicator_color2  Red
#property  indicator_color3  Yellow

#property  indicator_width1  4
#property  indicator_width2  4
#property  indicator_width3  4

//---- indicator parameters----------------

extern int MaPeriod       =20;  // 
extern int MaMethod_0to3  =1; // 0 = SMA, 1 = EMA, 2 = SMMA, 3 = LWMA
extern int AppliedPrice_0to6=  0; // 0 = Close, 1 = Open, 2 = High, 3 = Low, 4 = Median, 5 = Typical, 6 = Weighted Close
//---- indicator buffers
double Buffer1[];
double Buffer2[];
double Buffer3[];

double c0;
double c1;
double c2;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(3);
//---- drawing settings

   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_DOT);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_DOT);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_DOT);

//---- 3 indicator buffers mapping------------------------------------

   SetIndexBuffer(0,Buffer1); 
   SetIndexBuffer(1,Buffer2);
   SetIndexBuffer(2,Buffer3);

//---- name for DataWindow and indicator subwindow label-------------

   //IndicatorShortName("rel position shading");
   IndicatorShortName("rel position shading");

//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//|
//| Defined MA position relative to 100BB (1 deviation)                                              |
//+------------------------------------------------------------------+

int start()
  {
   int nLimit, i;
   int nCountedBars;
   
   nCountedBars=IndicatorCounted();

//---- check for possible errors
   if(nCountedBars<0)
      return(-1);

//---- last counted bar will be recounted

   if(nCountedBars>0)
      nCountedBars--;
   nLimit=Bars-nCountedBars;
   
//---- main loop

   for(i=0; i<nLimit; i++)
     {
//----c0=Moving Average for comparison with Bollinger Band---------------      
      c0=(iMA(Symbol(),0,MaPeriod,0,MaMethod_0to3,AppliedPrice_0to6,i));
      
//----c1=Upper 100 Bollinger Band (1 standard deviation)-----------------
  
      c1=(iMA(Symbol(),0,100,0,MODE_SMA,PRICE_CLOSE,i)+iStdDev(NULL,0,100,0,MODE_SMA,PRICE_CLOSE,i));
      
//----c2=Lower 100 Bollinger Band (1 standard deviation)-----------------
      c2=(iMA(Symbol(),0,100,0,MODE_SMA,PRICE_CLOSE,i)+iStdDev(NULL,0,100,0,MODE_SMA,PRICE_CLOSE,i));
                   
//----If Moving average above Bollinger Band--------      
      if(c0>c1)
      Buffer1[i]=c0;Buffer2[i]=c1;
      
//----If Moving Average between Nollinger Bands-----    
      if(c0<=c1&&c0>=c2)
      Buffer2[i]=c1;Buffer3[i]=c2;
      
//----If Moving Average below Bollinger Bands------    
      if(c2>c0)
      Buffer3[i]=c2;Buffer1[i]=c0;
     
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+

